<template>
  <div v-show="visible">
    <a-row :gutter="48" slot="extra">
      <a-col :md="48" :sm="48">
        <span class="table-page-search-submitButtons" style="float: right">
          <a-button style="margin-left: 8px" @click="handleCancel()">返回</a-button>
        </span>
      </a-col>
    </a-row>
    <title-divider title="型号信息" width="90px"></title-divider>
    <detail-list title="" :col="3">
      <detail-list-item term="型号">{{ model.model }}</detail-list-item>
      <detail-list-item term="名称型号">{{ model.nameModel }}</detail-list-item>
      <detail-list-item term="设备名称">{{ model.name }}</detail-list-item>
    </detail-list>
    <title-divider title="BOM信息" width="90px"></title-divider>
    <div class="table-operator">
      <a-button type="primary" @click="handleAdd">
        <a-icon type="plus"/>
        关联BOM
      </a-button>
      <!--      <a-button style="margin-left:8px;" type="primary" @click="handleSpareSelect">
        <a-icon type="plus"/>
        关联BOM
      </a-button>-->
      <a-button style="margin-left:8px;" type="primary" @click="handleSbSelect">
        <a-icon type="plus"/>
        复制BOM
      </a-button>
      <a-button style="margin-left:8px;" type="primary" @click="handleSpareAdd">
        <a-icon type="plus"/>
        添加备件
      </a-button>

      <!--      <a-button style="margin-left: 8px" type="primary" icon="download" @click="downTemplate">下载模板</a-button>
      <a-button style="margin-left: 8px" type="primary" icon="download" @click="doExport">导出</a-button>
      <a-button style="margin-left:8px;" type="primary" @click="doImport">
        <a-icon type="upload"/>
        导入
      </a-button>-->
    </div>
    <a-table
      :data-source="data"
      :columns="columns"
      tableLayout="auto"
      rowKey="id">
      <span slot="action" slot-scope="record">
        <template>
          <a @click="handleEdit(record)">修改备件</a>
          <a-divider type="vertical" />
          <a @click="handleEditRelation(record)">修改bom</a>
          <a-divider type="vertical" />
          <a-popconfirm v-if="$auth('sb-infos-del')" title="是否要删除该条数据？" @confirm="batchDelete(record.id)">
            <a>取消bom</a>
          </a-popconfirm>
        </template>
      </span>
    </a-table>
    <base-form-sb ref="baseModalSb" @ok="handleOk"/>
    <base-form ref="baseModal" @ok="handleOk"/>
    <import-form-add ref="importModal" @ok="handleOk"></import-form-add>
    <spare-part-info-select-modal :type="'checkbox'" ref="spareSelectModal" @selected="handleSpareSelected"/>
    <sb-info-select-modal :type="'radio'" ref="sbInfoSelectModal" @selected="handleSbSelectd"/>
  </div>
</template>

<script>
import DetailList from '@/components/tools/DetailList'
import { addSbModelBomBatch, copy, selectSpareInfoListBySbId, deleteSbModelBoms, exportSbModelBom } from '@/api/sb/modelbom'
import SparePartInfoSelectModal from '@/views/sqarepartmanage/sparepartinfo/modules/SparePartInfoSelectModal'
import BaseFormSb from './BaseFormSb'
import ImportFormAdd from './ImportFormAdd'
import BaseForm from '@/views/sqarepartmanage/sparepartinfo/modules/BaseForm'
import { fetchSparePartInfo } from '@/api/sqarepartmanage/sparepartinfo'
import SbInfoSelectModal from '@/views/sb/info/modules/SbInfoSelectModal'
const DetailListItem = DetailList.Item

export default {
  name: 'SbBomDetail',
  components: {
    DetailList,
    DetailListItem,
    BaseFormSb,
    SparePartInfoSelectModal,
    ImportFormAdd,
    BaseForm,
    SbInfoSelectModal
  },
  data () {
    return {
      confirmLoading: false,
      mdl: {},
      model: {
        'id': null,
        'modelId': null,
        'no': null,
        'name': null,
        'nameModel': null,
        'unit': null,
        'level': null,
        'useType': null
      },
      modalTitle: null,
      visible: false,
      useTypeMap: {},
      levelMap: {},
      unitMap: {},
      periodTypeMap: {},
      // 表头
      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          customRender: (text, record, index) => {
            return `${index + 1}`
          }
        },
        {
          title: '部位',
          dataIndex: 'sbPartName'
        },
        {
          title: '名称',
          dataIndex: 'name'
        },
        {
          title: '编码',
          dataIndex: 'no'
        },
        {
          title: '自编号',
          dataIndex: 'zbh'
        },
        {
          title: '规格型号',
          dataIndex: 'ggxh'
        },
        {
          title: '更换周期',
          dataIndex: 'period',
          customRender: (text, record, index) => {
            return text + this.BaseTool.Table.getMapText(this.periodTypeMap, record.periodType)
          }
        },
        {
          title: '更换日期',
          dataIndex: 'checkDate'
        },
        {
          title: '下次更换日期',
          dataIndex: 'nextCheckDate'
        },
        {
          title: '数量',
          dataIndex: 'num'
        },
        {
          title: '助记码',
          dataIndex: 'zjm'
        },
        {
          title: '操作',
          key: 'action',
          checked: true,
          align: 'center',
          // fixed: 'right',
          scopedSlots: { customRender: 'action' }
        }
      ],
      data: []
    }
  },
  created () {
    // 下拉框map
    this.depreciationTypeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SBINFO_DEPRECIATIONTYPE)
    this.levelMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SBINFO_LEVEL)
    this.statusMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SB_MODEL_RECOMMEND)
    this.unitMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SBINFO_UNIT)
    this.enableMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.YES_NO)
    this.typeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.CHECK_STANDARD_TYPE)
    this.useTypeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SB_USE_TYPE)
    this.periodTypeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.CHECK_PLAN_PERIOD_TYPE)
  },
  methods: {
    base (record) {
      this.visible = true
      this.model = record
      this.modalTitle = '详情Bom'
      selectSpareInfoListBySbId({ id: record.id }).then(res => {
        this.data = res.data
      })
    },
    handleOk () {
      selectSpareInfoListBySbId({ id: this.model.id }).then(res => {
        this.data = res.data
      })
    },
    handleSpareSelect () {
      this.$refs.spareSelectModal.base({})
    },
    handleSpareSelected (record, keys, rows) {
      const addData = []
      for (let i = 0; i < rows.length; i++) {
        addData.push({ sbId: this.model.id, spareId: rows[i].id, spareName: rows[i].name, num: 1, period: 500, periodType: 6 })
      }
      addSbModelBomBatch(addData)
        .then((response) => {
          this.$message.info('批量添加成功')
          this.handleOk()
        }).catch(() => {
          this.confirmLoading = false
        })
    },
    handleAdd () {
      const modal = this.$refs.baseModalSb
      modal.base({ sbId: this.model.id })
    },
    handleSpareAdd () {
      const modal = this.$refs.baseModal
      modal.base(null, this.model.id)
    },
    handleEdit (record) {
      fetchSparePartInfo({ id: record.spareId }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data)
      })
    },
    handleEditRelation (record) {
      const modal = this.$refs.baseModalSb
      modal.base(record)
    },
    handleCancel () {
      this.visible = false
      this.confirmLoading = false
      this.$emit('ok')
    },
    doImport () {
      this.$refs.importModal.base(this.model.id)
    },
    downTemplate () {
      const a = document.createElement('a')
      a.href = this.DictCache.getValueByCode(this.DictCache.TYPE.FILE_DOWNLOAD_TEMPLATE, 'SB_MODEL_BOM_DOWNLOAD_TEMPLATE')
      a.target = '_blank'
      a.click()
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteSbModelBoms(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
      })
    },
    doExport () {
      const parameter = {
        ...this.queryParam
      }
      parameter.modelId = this.model.id
      exportSbModelBom(parameter).then(file => {
        this.BaseTool.UPLOAD.downLoadExportExcel(file)
      })
    },
    handleSbSelect () {
      this.$refs.sbInfoSelectModal.base()
    },
    handleSbSelectd (keys, rows) {
      const [ key ] = keys
      const [ row ] = rows
      // 日期处理
      copy({ sbId: this.model.id, copySbId: row.id })
        .then((response) => {
          this.$message.info(response.data)
          this.handleOk()
        }).catch(() => {
          this.confirmLoading = false
        })
    }
  }
}
</script>
